/*
**  File Name : dirlist.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**                         ̧  ޳
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <ctype.h>
#include <jctype.h>
#include <dos.h>
#include <string.h>
#include "uiglib.h"

/*
** ̧ Ҳ ݽ׸ 
**   ̧ Ҳ ݻ    ų
*/
DIRLIST::DIRLIST(char* fn, int m)
{
	strcpy(dir, fn);
	mode = m;
	flg = findfirst(dir, &finf, mode);
}

/*
** 
*/
void	DIRLIST::reset(char* fname, int m)
{
	if (fname) {
		strcpy(dir, fname);
		mode = m;
	}
	flg = findfirst(dir, &finf, mode);
}

/*
** ̧ Ҳ ݻ
*/
int	DIRLIST::pathname0(char* fname, int& attr)
{
	int	ret = !flg;
	if (ret) {
		attr    = finf.ff_attrib;
		sprintf(fname, "%s", finf.ff_name);
		flg = findnext(&finf);
		for (int i=0;fname[i];i++) {
			if (iskanji(fname[i])) {
				i++;
				continue;
			}
			if (isupper(fname[i])) {
				fname[i]=tolower(fname[i]);
			}
		}
	}
	return(ret);
}

/*
** ̧ Ҳ ݻ
*/
int	DIRLIST::pathname(char* fname, int& attr)
{
	int	ret;
	if ((mode&0x07)==0 && (mode&0x10)) {
		while (1) {
			ret = pathname0(fname, attr);
			if ((attr&0x10)||ret==0) {
				break;
			}
		}
	} else {
		ret = pathname0(fname, attr);
	}
	return(ret);
}

static void make_path(char* path, char* dir, char* wc)
{
	int	len = strlen(dir);
	if (len == 0) {
		strcpy(path, wc);
	} else if (dir[len-1]=='\\') {
		sprintf(path, "%s%s", dir, wc);
	} else {
		sprintf(path, "%s\\%s", dir, wc);
	}
}

DIRLIST2::DIRLIST2(char* d, char* w0, char* w1, char* w2):DIRLIST("")
{
	dir = d;
	mode[0] = 0x10; mode[1] = mode[2] = mode[3] = 0x07;
	wc[0] = "*.*"; wc[1] = w0; wc[2] = w1; wc[3] = w2; wc[4]= 0;
	wcnt = 0;
	make_path(path, dir, wc[wcnt]);
	DIRLIST::reset(path, mode[wcnt]);
}

void	DIRLIST2::reset(char* d, char* w0, char* w1, char *w2)
{
	if (d) dir = d;
	mode[0] = 0x10; mode[1] = mode[2] = mode[3] = 0x07;
	wc[0] = "*.*"; 
	if (w0) wc[1] = w0;
	if (w1) wc[2] = w1;
	if (w2) wc[3] = w2;
	wc[4]= 0;
	wcnt = 0;
	make_path(path, dir, wc[wcnt]);
	DIRLIST::reset(path, mode[wcnt]);
}

int	DIRLIST2::pathname(char* fname, int& attr)
{
	int	ret;

	if ((ret = DIRLIST::pathname(fname, attr))==0) {
		wcnt++;
		while (wc[wcnt]) {
			make_path(path, dir, wc[wcnt]);
			DIRLIST::reset(path, mode[wcnt]);
			ret = DIRLIST::pathname(fname, attr);
			if (ret) break;
			wcnt++;
		}
	}
	return(ret);
}

// end of dirlist.cpp
