/*
**  File Name : files.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**                         ̧  ޳
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include "uiglib.h"

/*
** ̧ٖ̕\
*/
void	FILES_SELECT_FNAME::display(PANEL& p)
{
	char	msg[16];
	if ((*fattr)&0x10) {
		sprintf(msg, "<%-12.12s>", buffer);
	} else {
		sprintf(msg, " %-12.12s ", buffer);
	}
	p.locate(line, column-1);
	p.color(attribute);
	p.puts(msg);
}

/*
** ̧ٖ̓
*/
int	FILES_SELECT_FNAME::activate(PANEL& p)
{
	if (strcmp(buffer, "               ")==0) {
		return(PANEL_RESUME);
	}
	FILES_WINDOW	*fw;
	fw = (FILES_WINDOW *)&p;
	fw->set_fname(buffer, *fattr);
	SELECT::activate(p);
	return(PANEL_CONTINUE);
}

/*
** ̧   ޳
*/
FILES_WINDOW::FILES_WINDOW(int l, int c, char* d, char* w0, char* w1, char* w2):
	      PANEL(l, c, 11, 69, FRAME0), DIRLIST2(d, w0, w1, w2)
{
	for (int i=0;i<24;i++) {
		strcpy(fnames[i], "               ");
	}
	getcwd(cwd_save, sizeof(cwd_save));
	if (strchr(d, ':')) {
		setdisk(toupper(*d) - 'A');
	}
	::chdir(d);
	getcwd(cwd, sizeof(cwd));
	sprintf(header0,"[%-31.31s]", cwd);
	if (w1 == 0 && w2 == 0) {
		sprintf(header1,"[%s]", w0);
	} else if (w2==0) {
		sprintf(header1,"[%s %s]", w0, w1);
	} else {
		sprintf(header1,"[%s %s %s]", w0, w1, w2);
	}
	parts[nparts++] = new MESSAGE(2,2, ATTR_CYAN, header0);
	parts[nparts++] = new MESSAGE(2,38, ATTR_CYAN, header1);
	fname_start = nparts;
	for (i=0;i<6;i++) {
		parts[nparts++] = new FILES_SELECT_FNAME(3+i, 3, ATTR_YELLOW, fnames[i*4+0], &attr[i*4+0]);
		parts[nparts++] = new FILES_SELECT_FNAME(3+i,20, ATTR_YELLOW, fnames[i*4+1], &attr[i*4+1]);
		parts[nparts++] = new FILES_SELECT_FNAME(3+i,37, ATTR_YELLOW, fnames[i*4+2], &attr[i*4+2]);
		parts[nparts++] = new FILES_SELECT_FNAME(3+i,54, ATTR_YELLOW, fnames[i*4+3], &attr[i*4+3]);
	}
	parts[nparts++] = new BUTTON(10, 16, ATTR_GREEN,"F1:\", KEY_PF1, FRAME0, ATTR_CYAN, "view");
	parts[nparts++] = new BUTTON(10, 25, ATTR_GREEN,"RUP:߰", KEY_NEXT, FRAME0, ATTR_CYAN, "rollup");
	parts[nparts++] = new BUTTON(10, 38, ATTR_GREEN,"RDWN:O߰", KEY_PREV, FRAME0, ATTR_CYAN, "rolldown");
	parts[nparts++] = new BUTTON(10, 52, ATTR_GREEN,"CR:I", KEY_CR, FRAME0, ATTR_CYAN, "select");
	parts[nparts++] = new BUTTON_QUIT(10, 61, ATTR_GREEN,"ESC:f", KEY_ESC, FRAME0);
}

FILES_WINDOW::~FILES_WINDOW()
{
	if (strchr(cwd_save, ':')) {
		setdisk(toupper(*cwd_save) - 'A');
	}
	::chdir(cwd_save);
}

void FILES_WINDOW::open()
{
	start = 0;
	ndisp = set_buffer(start);
	PANEL::open();
}

int FILES_WINDOW::activate()
{
	int	ret;
	if (ndisp) {
		ret = PANEL::activate();
	} else {
		printf("\007");
		POPWIN_WAIT	popwin(10,30,"t@C܂B");
		popwin.open();
		popwin.activate();
		popwin.close();
		ret = 0;
	}
	return(ret);
}

int	FILES_WINDOW::function(char *func)
{
	int	ret=PANEL_RESUME;
	if (strcmp(func, "select")==0) {
		if (chdir()) {
			ret = PANEL_RESUME;
		} else {
			ret = 1;
		}
	} else if (strcmp(func, "rollup")==0) {
		next_page();
	} else if (strcmp(func, "rolldown")==0) {
		prev_page();
	} else if (strcmp(func, "view")==0) {
		view();
	}
	return(ret);
}

char	*FILES_WINDOW::selected_fname()
{
	int	len = strlen(cwd);
	if (len == 0) {
		strcpy(path_name, point_fname);
	} else if (cwd[len-1]=='\\') {
		sprintf(path_name, "%s%s", cwd, point_fname);
	} else {
		sprintf(path_name, "%s\\%s", cwd, point_fname);
	}
	return(path_name);
}

int FILES_WINDOW::set_buffer(int n)
{
	int	at, ret;
	char	fname[16];
	reset(cwd);
	for (int i=0;i<n;i++) {
		if (pathname(fname, at)==0) {
			break;
		}
	}
	for (i=0;i<24;i++) {
		if (pathname(fname, attr[i])==0) {
			break;
		}
		sprintf(fnames[i], "%-12.12s", fname);
	}
	ret = i;
	if (ret) {
		for (;i<24;i++) {
			strcpy(fnames[i], "               ");
			attr[i] = 0x00;
		}
	}
	return(ret);
}

int	FILES_WINDOW::next_page()
{
	int	ret = 0;
	int	nd;
	if ((nd=set_buffer(start+24))!=0) {
		ndisp = nd;
		start += 24;
		display();
		if (before_parts()-fname_start >= ndisp) {
			set_active_parts(parts[fname_start+ndisp-1]);
		}
		ret = 1;
	}
	return(ret);
}

int	FILES_WINDOW::prev_page()
{
	int	ret = 0;
	if ((start-24)>=0) {
		ndisp = set_buffer(start-24);
		start -= 24;
		display();
		ret = 1;
	}
	return(ret);
}

/*
**  ۰ 
*/
int	FILES_WINDOW::up_scroll(void)
{
	if (prev_page()) {
		int fno = before_parts() - fname_start;
		fno %= 4;
		set_active_parts(parts[fname_start+20+fno]);
	}
	return(PANEL_CONTINUE);
}

/*
**  ۰ 
*/
int	FILES_WINDOW::down_scroll(void)
{
	if (next_page()) {
		int fno = before_parts() - fname_start;
		fno %= 4;
		if (fno >= ndisp) {
			fno = ndisp - 1;
		}
		set_active_parts(parts[fname_start+fno]);
	}
	return(PANEL_CONTINUE);
}

/*
**   ۰ 
*/
int	FILES_WINDOW::left_scroll(void)
{
	int fno = before_parts() - fname_start;
	if (fno == 0) {
		if (prev_page()) {
			set_active_parts(parts[fname_start+23]);
		}
	}
	return(PANEL_CONTINUE);
}

/*
** з ۰ 
*/
int	FILES_WINDOW::right_scroll(void)
{
	int fno = before_parts() - fname_start;
	if (fno == 23) {
		if (next_page()) {
			set_active_parts(parts[fname_start]);
		}
	}
	return(PANEL_CONTINUE);
}

int	FILES_WINDOW::chdir()
{
	int	ret;
	if (point_attr&0x10) {
		::chdir(point_fname);
		getcwd(cwd, sizeof(cwd));
		sprintf(header0,"[%-31.31s]", cwd);
		start = 0;
		ndisp = set_buffer(start);
		display();
		set_active_parts(parts[fname_start]);
		ret = 1;
	} else {
		ret = 0;
	}
	return(ret);
}

void	FILES_WINDOW::view()
{
	if (point_attr&0x10) {
		return;
	}
	TEXT_VIEW	p(5,1,15,80,point_fname,TV_VIEW);
	p.open();
	p.activate();
	p.close();
}

// end of files.cpp
