/*
** qa
**
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include "uiglib.h"

/*
** e[u
*/
static	char*	num_tbl[] = {
	"O", "P", "Q", "R", "S", 
	"T", "U", "V", "W", "X"
};

static	int	pos[][2] = {
	{40,  4},
	{52,  6},
	{58, 10},
	{58, 14},
	{52, 18},
	{40, 20},
	{28, 18},
	{22, 14},
	{22, 10},
	{28,  6},
};

/*
** ͐l
*/
class INPUT_NO : public INPUT {
public:
	INPUT_NO(int l, int c, unsigned int a, char *b):
		INPUT(l, c, a, b, FRAME0, ATTR_YELLOW) {}
	virtual	int activate(PANEL& p);
};

/*
**  ROTATE BOX pl
*/
class	RBPANEL : public PANEL {
	friend	class	INPUT_NO;
protected:
	int	ntbl[10];
	int	count;
	char	no[10][3];
	char	ino[3];
	char	msg[80];
public:
	RBPANEL(int l, int c, int ll, int lc);
	virtual	int	function(char* func);
	virtual	void	display(void);
	virtual void	clear_buffer(void);
	virtual	void	reset(void);
	virtual	void	rotate(int n);
};

/*
** ROTATE BOX pl̃RXgN^
*/
RBPANEL::RBPANEL(int l, int c, int ll, int lc) : PANEL(l, c, ll, lc, FRAME0)
{
	/* bZ[W */
	sprintf(msg,"萔 [%03d]",count);
	parts[nparts++] = new MESSAGE(22,5,ATTR_WHITE,msg);
	parts[nparts++] = new MESSAGE(pos[0][1], pos[0][0], ATTR_WHITE, no[0], FRAME0, ATTR_RED);
	for (int i=1;i<10;i++) {
		parts[nparts++] = new MESSAGE(pos[i][1], pos[i][0], ATTR_WHITE, no[i]);
	}
	/* ͍ */
	parts[nparts++] = new INPUT_NO(12, pos[0][0], ATTR_WHITE, ino);
	parts[nparts++] = new BUTTON(ll-1,lc-19,ATTR_GREEN, "HELP:", KEY_HELP, FRAME0, ATTR_CYAN, "help");
	parts[nparts++] = new BUTTON(ll-1,lc-28,ATTR_GREEN,  "F1:ؾ", KEY_PF1, FRAME0, ATTR_CYAN, "reset");
	parts[nparts++] = button_exit = 
			  new BUTTON_EXIT(ll-1,lc-8,ATTR_GREEN, "ESC:I", KEY_ESC, FRAME0);
}

/*
** RBPANEL̓@\ďo
*/
int	RBPANEL::function(char* func)
{
	int	ret = PANEL_RESUME;
	if (strcmp(func, "help")==0) {
		TEXT_VIEW	help(5, 10, 16, 62, "rb.hlp",TV_VIEW);
		help.open();
		help.activate();
		help.close();
	} else if (strcmp(func, "reset")==0) {
		POPWIN_YES_NO	pop(15,30," Zbg܂@H ");
		pop.open();
		int ret = pop.activate();
		pop.close();
		if (ret) reset();
	}
	return(ret);
}

/*
** RBPANEL̕\
*/
void	RBPANEL::display()
{
	for (int i=0;i<10;i++) {
		strcpy(no[i], num_tbl[ntbl[i]]);
	}
	sprintf(msg,"萔 [%03d]",count);
	PANEL::display();
}

/*
** RBPANEL̃obt@NA
*/
void	RBPANEL::clear_buffer()
{
	strcpy(ino, "@");
	count = 0;
	for (int i=0;i<10;i++) {
		ntbl[i] = 0;
		strcpy(no[i], num_tbl[ntbl[i]]);
	}
}

/*
**  q
*/
void	RBPANEL::reset()
{
	randomize();
	for (int i=0;i<10;i++) {
		ntbl[i] = rand() % 10;
	}
	count = 0;
	display();
}

/*
** q
*/
void	RBPANEL::rotate(int n)
{
	if (n<=ntbl[0]) {
		ntbl[0] -= n;
	} else {
		ntbl[0] = ((ntbl[0]+n)%10);
	}
	count++;
	display();
	int	zflg = 1;
	for (int i=0;i<10;i++) {
		if (ntbl[i]) {
			zflg = 0;
			break;
		}
	}
	if (zflg) {
		printf("\007\007\007");
		char	msg[80];
		sprintf(msg, "%d ŏI܂B",  count);
		POPWIN_WAIT	pw(10, 30, msg);
		pw.open();
		pw.activate();
		pw.close();
	} else {
		for (i=0;i<n;i++) {
			int	tmp = ntbl[9];
			for (int j=8;j>=0;j--) {
				ntbl[j+1] = ntbl[j];
			}
			ntbl[0] = tmp;
			printf("\007");
			display();
			delay(500);
		}
	}
}

/*
** ͍ڂ͓̓
*/
int	INPUT_NO::activate(PANEL& p)
{
	while (1) {
		INPUT::display(p);
		p.event_wait();
		if (p.event_type()==KEY_PRESSED) {
			int	key = p.key_code();
			if ('1'<=key && key <= '9') {
				strcpy(buffer, num_tbl[key-'0']);
				RBPANEL	*rb;
				rb = (RBPANEL *)&p;
				rb->rotate(key-'0');
				break;
			} else {
				printf("\007");
				break;
			}
		} else {
			break;
		}
	}
	INPUT::display(p);
	return(PANEL_CONTINUE);
}

/*
** C[`
*/
main()
{
	RBPANEL	p(1,1,24,80);		// pl쐬
	p.open();			// pl̃I[v
	p.reset();
	p.display();
	p.activate();			// pl𓮍삳
	p.close();			// plN[YB
}

// end of file
