/*
** File Name : txtbuf.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**			TEXT_BUFFER CLASS
**                      ~~~~~~~~~~~~~~~~~
*/

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <dir.h>
#include <dos.h>
#include <jctype.h>
#include "uiglib.h"

/*
** ÷ޯ̧̺ݽ׸
*/
TEXT_BUFFER::TEXT_BUFFER(char* fn, int ls)
{
	error_flg = 0;
	line_size = ls+1;
	fp = NULL;
	line_index = NULL;
	fp = fopen(fn, "rb");
	if (fp == NULL) {
		error_flg = 1;
		return;
	}
	buffer = new unsigned char[BUFFER_SIZE];
	if (buffer==0) {
		fprintf(stderr, "TEXT_BUFFER::TEXT_BUFFER:؂܂B\n");
		exit(1);
	}
	fseek(fp, 0L, SEEK_END);
	size = ftell(fp);
	offset = 0L;
	fseek(fp, 0L, SEEK_SET);
	fread(buffer, BUFFER_SIZE, 1, fp);
	make_line_index();
}

TEXT_BUFFER::TEXT_BUFFER(char* b, int bs, int ls)
{
	error_flg = 0;
	line_index = NULL;
	fp = NULL;
	line_size = ls+1;
	offset = 0L;
	buffer = (unsigned char *)b;
	size   = bs;
	make_line_index();
}

/*
** ÷ޯ̧޽׸
*/
TEXT_BUFFER::~TEXT_BUFFER()
{
	if (line_index) {
		delete line_index;
	}
	if (fp) {
		delete buffer;
		fclose(fp);
	}
}

/*
**@ײݲޯ̍쐬
*/
void	TEXT_BUFFER::make_line_index()
{
	long	ptr = 0;
	int	c;
	int	l=0, i=0;
	line_index = new long[BUFFER_SIZE];
	if (line_index==0) {
		fprintf(stderr, "TEXT_BUFFER::make_line_index:؂܂B\n");
		exit(1);
	}
	fseek(fp, 0L, SEEK_SET);
	while (1) {
		if (i>=MAX_LINE-1) break;
		if (l==0) {line_index[i]=ptr;i++;}
		c = get_char(ptr);
		ptr ++;
		if (ptr>=size) break;
		if (c=='\n') {
			if (l==0) i--;
			l = 0;
		} else if (c=='\t') {
			int	tab = (l+8)&0xfff8;
			if (tab<line_size) {
				l = tab;
			} else {
				l = line_size;
			}
		} else {
			l++;
			if (iskanji(c)) {
				if (l<line_size-1) {
					l++;
					c = get_char(ptr);
					ptr++;
				} else {
					l = line_size;
				}
			}
		}
		if (l>=line_size) {
			l=0;
			ptr--;
		}
	}
	lines = i;
	line_index[i]=ptr;
}

/*
** ޯ̧̽ܯ
*/
void	TEXT_BUFFER::swap_buffer(long off0, long off1, int step)
{
	if (off0 < offset) {
		offset = off0 - step;
		if (offset < 0) offset = 0;
		fseek(fp, offset, SEEK_SET);
		fread(buffer, BUFFER_SIZE, 1, fp);
	} else if (offset+BUFFER_SIZE < off1) {
		offset = off1 - step;
		fseek(fp, offset, SEEK_SET);
		fread(buffer, BUFFER_SIZE, 1, fp);
	}
}

/*
** 1o
*/
int	TEXT_BUFFER::get_char(long off)
{
	swap_buffer(off, off, 0);
	return(buffer[off-offset]);
}

/*
**  Pso
*/
void	TEXT_BUFFER::get_line(int lno, char* buf)
{
	swap_buffer(line_index[lno], line_index[lno+1], BUFFER_SIZE/2);
	int	i = line_index[lno] - offset;
	for (int j=0;i<line_index[lno+1]-offset;i++) {
		if (j>=line_size-1) break;
		int	c = buffer[i];
		if (c=='\t') {
			int	tab = (j+8)&0xfff8;
			if (tab>=line_size) break;
			memset(&buf[j], ' ', tab - j);
			j = tab;
		} else if (c=='\r' || c=='\n' || c==0x1a || c=='\0') {
			buf[j] = ' ';
			j++;
		} else {
			buf[j] = c;
			j++;
		}
	}
	memset(&buf[j], ' ', line_size-j-1);
	buf[line_size-1]='\0';
}

// end of file
