;====================================================================
;
;	EQU OF CD-ROM DRIVE INTERFACE
;
;	88/07/04	Takaki.Kobayashi
;
;====================================================================
;
S_BSY		equ	$80	;%1000_0000	P_SCSI
S_REQ		equ	$40	;%0100_0000	P_SCSI
S_MSG		equ	$20	;%0010_0000	P_SCSI
S_CXD		equ	$10	;%0001_0000	P_SCSI
S_IXO		equ	$08	;%0000_1000	P_SCSI
ACK		equ	$80	;%1000_0000	P_INTCTL
RST		equ	$02	;%0000_0010	P_PORT
;
PHS_COM		equ	(S_BSY + S_REQ +         S_CXD        )
PHS_DOT		equ	(S_BSY + S_REQ                        )
PHS_DIN		equ	(S_BSY + S_REQ +                 S_IXO)
PHS_SIN		equ	(S_BSY + S_REQ +         S_CXD + S_IXO)
PHS_MOT		equ	(S_BSY + S_REQ + S_MSG + S_CXD        )
PHS_MIN		equ	(S_BSY + S_REQ + S_MSG + S_CXD + S_IXO)

P_SCSI		equ	$1800	;(R) drive control line I/O
P_SEL		equ	$1800	;(W) drive control line I/O
			;+------+------+------+------+------+------+------+------+
			;| BUSY | REQ  | MSG  | CXD  | IXO  | ---- | ---- | ---- |
			;+------+------+------+------+------+------+------+------+

P_DATA		equ	$1801	;(R/ ) command data line input
P_CMD		equ	$1801	;( /W) command data line output
			;+------+------+------+------+------+------+------+------+
			;|  D7  |  D6  |  D5  |  D4  |  D3  |  D2  |  D1  |  D0  |
			;+------+------+------+------+------+------+------+------+

P_INTCTL	equ	$1802	;(R/W) ACK On/Off & INT mode set
			;+------+------+------+--------+---------+------+----+----+
			;| ACK  |INTDEN|INTMEN|INTSUBEN|INTSTOPEN|INTAEN| -- | -- |
			;+------+------+------+--------+---------+------+----+----+

P_INTMON	equ	$1803	;(R/O) interapt monitor
			;+------+------+------+------+-------+------+------+------+
			;| ---- | INTD | INTM |INTSUB|INTSTOP| INTA |AUDL/R| ---- |
			;+------+------+------+------+-------+------+------+------+

P_PORT		equ	$1804	;(R/W) sub I/O
			;+------+------+------+------+------+------+------+------+
			;| ---- | ---- | ---- |  P3  |P0 I/O|  P2  |RESET |  P0  |
			;+------+------+------+------+------+------+------+------+

P_AUDL		equ	$1805	;(R/W) PCM AUDIO data read LOW
			;+------+------+------+------+------+------+------+------+
			;|  D7  |  D6  |  D5  |  D4  |  D3  |  D2  |  D1  |  D0  |
			;+------+------+------+------+------+------+------+------+

P_AUDH		equ	$1806	;(R/O) PCM AUDIO data read HIGH
			;+------+------+------+------+------+------+------+------+
			;|  D15 |  D14 |  D13 |  D12 |  D11 |  D10 |  D9  |  D8  |
			;+------+------+------+------+------+------+------+------+

P_SUBC		equ	$1807	;(R/W) SUB CODE paralel read & BACK UP RAM EN
			;+------+------+------+------+------+------+------+------+
			;| SCOR |   Q  |   R  |   S  |   T  |   U  |   V  |   W  |
			;+------+------+------+------+------+------+------+------+
			;|BACKEN| ---- | ---- | ---- | ---- | ---- | ---- | ---- |
			;+------+------+------+------+------+------+------+------+

P_DREG		equ	$1808	;(R/ ) auto handshake data input
P_ADL		equ	$1808	;( /W) address ratch low
			;+------+------+------+------+------+------+------+------+
			;|  A8  |  A7  |  A6  |  A5  |  A4  |  A3  |  A2  |  A1  |
			;+------+------+------+------+------+------+------+------+

P_ADH		equ	$1809	;(W/O) address ratch high
			;+------+------+------+------+------+------+------+------+
			;|  A16 |  A15 |  A14 |  A13 |  A12 |  A11 |  A10 |  A9  |
			;+------+------+------+------+------+------+------+------+

P_DRAM		equ	$180a	;(R/W) ADPCM buff <--> CPU data communication
			;+------+------+------+------+------+------+------+------+
			;|  D7  |  D6  |  D5  |  D4  |  D3  |  D2  |  D1  |  D0  |
			;+------+------+------+------+------+------+------+------+

P_TRCTL		equ	$180b	;(R/W) ADPCM data trans control
			;+------+------+------+------+------+------+------+------+
			;| ---- | ---- | ---- | ---- | ---- | ---- |ADTR 1|ADTR 0|
			;+------+------+------+------+------+------+------+------+

P_ADSTAT	equ	$180c	;(R/O) ADPCM status in
			;+------+------+------+------+------+------+------+------+
			;|DR BSY| ---- | ---- | ---- |AD BSY|DW BSY| ---- |AD END|
			;+------+------+------+------+------+------+------+------+

P_ADCTL		equ	$180d	;(R/W) ADPCM play control
			;+------+------+------+------+------+------+------+------+
			;|RST AD|AUTSTP|ADP ON|LN LDC| RD LD| RD CK| WR LD| WR CK| 
			;+------+------+------+------+------+------+------+------+

P_DIVPT		equ	$180e	;(R/W) ADPCM sampling late set
			;+------+------+------+------+------+------+------+------+
			;| ---- | ---- | ---- | ---- | DIV D| DIV C| DIV B| DIV A|
			;+------+------+------+------+------+------+------+------+

P_FDECTL	equ	$180f	;(R/W) MUTE / FADE OUT control
			;+------+------+------+------+-------+------+------+------+
			;| TEST | ---- | ---- | ---- |FADEOUT|TC SEL|AD/LIN| MUTE |
			;+------+------+------+------+-------+------+------+------+

P_EXMOPN_I	equ	$18c0	;(W/O) Internal EXT Memory Open
P_EXMSTS_I0	equ	$18c1	;(R/O) $aa
P_EXMSTS_I1	equ	$18c2	;(R/O) $55
P_EXMSTS_I2	equ	$18c3	;(R/O) size (* 64Kbytes)

P_EXMSTS_C0	equ	$18c5	;(R/O) $aa
P_EXMSTS_C1	equ	$18c6	;(R/O) $55
P_EXMSTS_C2	equ	$18c7	;(R/O) size (* 64Kbytes)
