;==============================================================================
;    PC-engine constant Header 
;------------------------------------------------------------------------------
;<< common file in Alfa System >>
;      Ver 1.00  1989-02-01
; modify  Apr. 21, 1989  Double 7up, Priority controler
;=============================================================================
;-----------------------------------------------------------------------------
;	assember CPU select
;-----------------------------------------------------------------------------
	cpu	'6280'
	
	public	STACK		
	public	RG7UP		
	public	LO7UP		
	public	HI7UP		
	public	PATTY_PRR	
	public	PATTY_PXR1	
	public	PATTY_PXR2	
	public	PATTY_STR	
	public	RG7UP2		
	public	LO7UP2		
	public	HI7UP2		
	public	TEKKAN		
	public	LOTAD		
	public	HITAD		
	public	LOTDT		
	public	HITDT		
	public	PSG_R0		
	public	PSG_R1		
	public	PSG_R2		
	public	PSG_R3		
	public	PSG_R4		
	public	PSG_R5		
	public	PSG_R6		
	public	PSG_R7		
	public	PSG_R8		
	public	PSG_R9		
	public	TIMREG		
	public	TIMCTR		
	public	JOYIO		
	public	KPORT		
	public	OPORT		
	public	IRQDIS		
	public	IRQREG		
;-----------------------------------------------------------------------------
;	stack access displasement
;-----------------------------------------------------------------------------
STACK	EQU	$2101
;-----------------------------------------------------------------------------
;       C6270(7UP) port address define
;-----------------------------------------------------------------------------
RG7UP		equ	$0000		;R/W select 7up register
LO7UP		equ	$0002		;R/W low byte to 7up
HI7UP		equ	$0003		;R/W high byte to 7up
;----------------------------------------------------------------------------;
;       HuC6202 Priority controler
;----------------------------------------------------------------------------;
PATTY_PRR	equ	$0008		; priority register
PATTY_PXR1	equ	$000a		; xW1
PATTY_PXR2	equ	$000c		; xW2
PATTY_STR	equ	$000e		; stߐ register
;-----------------------------------------------------------------------------
;       C6270-2(7UP-2) port address define
;-----------------------------------------------------------------------------
RG7UP2		equ	$0010		;R/W select 7up2 register
LO7UP2		equ	$0012		;R/W low byte to 7up2
HI7UP2		equ	$0013		;R/W high byte to 7up2
;-----------------------------------------------------------------------------
;       C6260(TEKKANNON) port address define
;-----------------------------------------------------------------------------
TEKKAN		equ	$0400		;W/O tekkannonn display timing set
LOTAD		equ	$0402		;W/O low address register
HITAD		equ	$0403		;W/O high address register
LOTDT		equ	$0404		;R/W pallet low data register
HITDT		equ	$0405		;R/W pallet high data register
;-----------------------------------------------------------------------------
;       PSG port address define
;-----------------------------------------------------------------------------
PSG_R0		equ	$0800		;W/O select CHANEL 0-5		only one
PSG_R1		equ	$0801		;W/O main volum			only one
PSG_R2		equ	$0802		;W/O freq low			0-5 ch
PSG_R3		equ	$0803		;W/O freq high			0-5 ch
PSG_R4		equ	$0804		;W/O chanel volum		0-5 ch
PSG_R5		equ	$0805		;W/O left and right balans	0-5 ch
PSG_R6		equ	$0806		;W/O wave and DDA		0-5 ch
PSG_R7		equ	$0807		;W/O noise			4-5 ch
PSG_R8		equ	$0808		;W/O LFO frq		only one with 0-1
PSG_R9		equ	$0809		;W/O LFO control	only one with 0-1
;-----------------------------------------------------------------------------
;       TIMER port address define
;-----------------------------------------------------------------------------
TIMREG		equ	$0C00		;R/W time counter set
TIMCTR		equ	$0C01		;W/O time stop / start
;-----------------------------------------------------------------------------
;       JOYPAD port address define
;-----------------------------------------------------------------------------
JOYIO		equ	$1000		;R/W joystick i/o port
KPORT		equ	$1000		;R   read port 8 bit's
OPORT		equ	$1000		;w   write port 8 bit's
;-----------------------------------------------------------------------------
;       IRQ CONTROL port address define
;-----------------------------------------------------------------------------
IRQDIS		equ	$1402		;R/W IRQ mask
IRQREG		equ	$1403		;R/W IRQ str if write is irq clear
;-----------------------------------------------------------------------------
;       C6270(7UP) inside registers number define
;-----------------------------------------------------------------------------
MAWR		equ	0		;W/O vram wright address reg.
MARR		equ	1		;W/O vram read address reg.
VWR		equ	2		;W   vram data write reg.
VRR		equ	2		;R   vram dara read reg.
CR		equ	5		;W/O controll reg.
RCR		equ	6		;W/O raster counter reg.
BXR		equ	7		;W/O bg x scroll reg.
BYR		equ	8		;W/O bg y scroll reg.
MWR		equ	9		;W/O memory dot space setup.
HSR		equ	10		;W/O h-sync setup
HDR		equ	11		;W/O h-sync setup
VPR		equ	12		;W/O v-sync setup
VDR		equ	13		;W/O v-sync setup
VCR		equ	14		;W/O v-sync setup
DCR		equ	15		;W/O DMA control
SOUR		equ	16		;W/O DMA sou. address
DISR		equ	17		;W/O DMA dis. address
LENR		equ	18		;W/O DMA move counter
DVSSR		equ	19		;W/O SAT address setup
;-----------------------------------------------------------------------------
;       JOYPAD key constant define
;-----------------------------------------------------------------------------
JOYLEFT		equ	$80
JOYDOWN		equ	$40
JOYRIGHT	equ	$20
JOYUP		equ	$10
JOYSTART	equ	$08
JOYSELECT	equ	$04
JOYB		equ	$02
JOYA		equ	$01
;-----------------------------------------------------------------------------
;       BLOCK TRANS DEFINE
;-----------------------------------------------------------------------------
_tii		equ	$73
_tdd		equ	$c3
_tin		equ	$d3
_tia		equ	$e3
_tai		equ	$f3
_rts		equ	$60
;-----------------------------------------------------------------------------
;		VRAM to VRAM DMA Controls
;-----------------------------------------------------------------------------
SDMA_AUTO_ON	equ	%10000		; Auto SPR_DMA
VDMA_DES_INC	equ	%00000
VDMA_DES_DEC	equ	%01000
VDMA_SRC_INC	equ	%00000
VDMA_SRC_DEC	equ	%00100
VDMA_VINT_ON	equ	%00010		; 荞݋
SDMA_VINT_ON	equ	%00001		; XvCgcl`I荞݂nm

;-----------------------------------------------------------------------------
;	u荞ݎ̃Xe[^X`FbNp̃tO`
;-----------------------------------------------------------------------------
VDP_VBUSY	EQU	%100_0000
VDP_VSYNC	EQU	%010_0000
VDP_VMDMA	EQU	%001_0000
VDP_SPDMA	EQU	%000_1000
VDP_RSHIT	EQU	%000_0100
VDP_SPOVR	EQU	%000_0010
VDP_SPHIT	EQU	%000_0001

;-----------------------------------------------------------------------------
;	XvCgp̒`EKvɉĕς镔łB
;-----------------------------------------------------------------------------
ORGH	equ		32
ORGV	equ		64
SATBUF	equ		$7f00
;-----------------------------------------------------------------------------
;	16MByte D-RAM Card port
;-----------------------------------------------------------------------------
	public	DR0,A0L,A0M,A0H,I0L,I0H,O0L,O0H,CMD0
	public	DR1,A1L,A1M,A1H,I1L,I1H,O1L,O1H,CMD1
	public	DR2,A2L,A2M,A2H,I2L,I2H,O2L,O2H,CMD2
	public	DR3,A3L,A3M,A3H,I3L,I3H,O3L,O3H,CMD3

DR0	=	$1a00	;$1980		; f[^|[g
;
A0L	=	$1a02	;$1982		; AhX|[g
A0M	=	$1a03	;$1983
A0H	=	$1a04	;$1984

O0L	=	$1a05
O0H	=	$1a06
I0L	=	$1a07
I0H	=	$1a08
CMD0	=	$1a09

DR1	=	$1a10	;$1990		; f[^|[g
;
A1L	=	$1a12	;$1992		; AhX|[g
A1M	=	$1a13	;$1993
A1H	=	$1a14	;$1994

O1L	=	$1a15
O1H	=	$1a16
I1L	=	$1a17
I1H	=	$1a18
CMD1	=	$1a19

DR2	=	$1a20	; f[^|[g
;
A2L	=	$1a22	; AhX|[g
A2M	=	$1a23
A2H	=	$1a24

O2L	=	$1a25
O2H	=	$1a26
I2L	=	$1a27
I2H	=	$1a28
CMD2	=	$1a29

DR3	=	$1a30	; f[^|[g
;
A3L	=	$1a32	; AhX|[g
A3M	=	$1a33
A3H	=	$1a34

O3L	=	$1a35
O3H	=	$1a36
I3L	=	$1a37
I3H	=	$1a38
CMD3	=	$1a39


;-----------------------------------------------------------------------------
;       END OF FILE
;-----------------------------------------------------------------------------
